package igblan.life;

import java.io.Serializable;

public class Cell implements Serializable
{
	private static final long serialVersionUID = 1L;

	public final int x, y;

	public Cell(int x, int y)
	{
		this.x = x;
		this.y = y;
	}
	
	public boolean equals(Cell p) {return p != null && x == p.x && y == p.y;}

	public Cell plus(Cell p) {return new Cell(x + p.x, y + p.y);}
	public Cell minus(Cell p) {return new Cell(x - p.x, y - p.y);}
	public Cell negated() {return new Cell(-x, -y);}
	public Cell times(int n) {return new Cell (n * x, n * y);}
	
	public Cell plus(int x, int y)
		{return new Cell(this.x + x, this.y + y);}
	
	public Cell minus(int x, int y)
		{return new Cell(this.x - x, this.y - y);}
	
	public Cell min(Cell p)
		{return new Cell(Math.min(x, p.x), Math.min(y, p.y));}
	
	public Cell max(Cell p)
		{return new Cell(Math.max(x, p.x), Math.max(y, p.y));}
	
	boolean isZero() {return x == 0 && y == 0;}
	
	@Override
	public String toString() {return "(" + x + "," + y + ")";}
}
