/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package igblan.seedsOfDestruction;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Paul Chapman
 */
public class Nouns implements Serializable
{
	private static String[] nouns = buildNouns();
	private static String[] shuffledNouns;
	
	private static String[] buildNouns()
	{
		BufferedReader reader =
			new BufferedReader(
				new InputStreamReader(
					Nouns.class.getResourceAsStream("nouns.txt")));
		List<String> list = new ArrayList();
		
		try
		{
			while (true)
			{
				String s = reader.readLine();
				if (s == null) break;
				list.add(s);	
			}
			
			reader.close();
			return list.toArray(new String[0]);
		}
		catch (IOException ex)
		{
			Logger.getLogger(Nouns.class.getName()).log(Level.SEVERE, null, ex);
		}
		
		return null;
	}
	
	private int index = 0;
	
	Nouns()
	{
		List list = Arrays.asList(nouns.clone());
		Collections.shuffle(list, new Random());
		shuffledNouns = (String []) list.toArray();
	}
	
	Nouns(long seed)
	{
		List list = Arrays.asList(nouns.clone());
		Collections.shuffle(list, new Random(seed));
		shuffledNouns = (String []) list.toArray();
	}
	
	public String next()
	{
		index = (index + 1) % shuffledNouns.length;
		return shuffledNouns[index];
	}
}
