package igblan.seedsOfDestruction;

import igblan.life.Cell;
import igblan.life.LifePattern;
import igblan.seedsOfDestruction.ui.Frame;
import java.io.Serializable;

/**
 *
 * @author Paul Chapman
 */
public class SerializablePattern implements Serializable
{
	private static final long serialVersionUID = 1L;

	private String rle;
	private Cell origin;
	
	public SerializablePattern(LifePattern pattern)
	{
		rle = pattern.toRawRLE();
		origin = pattern.getBoundingBox().leftTop;
	}
	
	public LifePattern toPattern()
	{
		return Frame.emptyPattern.newPatternFromRLE(rle).translate(origin);
	}
}
